﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Syncfusion.UI.Xaml.Charts;

namespace RealtimeUpdate
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DispatcherTimer timer=new DispatcherTimer();
        ViewModel viewModel = new ViewModel();
        DateTime date = new DateTime(2014, 6, 1);
        Random random = new Random();
        double value = 400;

        public MainWindow()
        {
            InitializeComponent();
            timer.Start();
            timer.Tick += timer_Tick;
            timer.Interval = new TimeSpan(0, 0, 0, 5);
            Chart.Series[0].ItemsSource = viewModel;
        }

        void timer_Tick(object sender, EventArgs e)
        {
            value = viewModel[viewModel.Count - 1].Count;
            if(!(Axis.ZoomFactor<1) || !(Axis.ZoomPosition>0))
            {
                for (int i = 0; i < 2; i++)
                {
                    viewModel.Add(new DataValues(date, value));
                    date = date.Add(TimeSpan.FromDays(1));

                    if (random.NextDouble() > .5)
                    {
                        value += random.NextDouble();
                    }
                    else
                    {
                        value -= random.NextDouble();
                    }
                }
            }
        }
    }

    public class ViewModel : ObservableCollection<DataValues>
    {
        public ViewModel()
        {
            DateTime date = new DateTime(2014, 1, 1);
            Random random = new Random();
            double value = 600;
            for (int i = 0; i < 6; i++)
            {
                Add(new DataValues(date, value));
                date = date.Add(TimeSpan.FromDays(1));

                if (random.NextDouble() > .5)
                {
                    value += random.NextDouble();
                }
                else
                {
                    value -= random.NextDouble();
                }
            }
        }
    }

    public class DataValues
    {
        public DateTime Year { get; set; }

        public double Count { get; set; }

        public DataValues(DateTime year, double count)
        {
            Year = year;
            Count = count;
        }
    }
}
